<?php
/**
* @author Petar Maric <petar.maric@gmail.com>
* @copyright 
* @version 1.0.1 
*/

define('DOWNLOAD_URL', 'http://code.djangoproject.com/svn/django/trunk/'); //Must end with a '/'
define('OUTPUT_DIR', 'django_src'); //Do not, and I repeat do not, add a trailing slash!
define('PROXY_NAME', 'proxy.ftn.ns.ac.yu');
define('PROXY_PORT', '8080');


/*
	DO NOT touch anything below this line! Stop reading now, I MEAN IT!!!
*/

ini_set('max_execution_time', 0); //disable script timeout


/**
* Gets contents of a file throught proxy
* @param file url
* @return file-contents
*/
function proxy_url($url)
{
	$proxy_name = PROXY_NAME;
	$proxy_port = PROXY_PORT;
	$proxy_contents = '';
	
	$proxy_fp = fsockopen($proxy_name, $proxy_port);
	if (!$proxy_fp)
		return false;
	fputs($proxy_fp, "GET $url HTTP/1.0\r\nHost: $proxy_name\r\n\r\n");
	while(!feof($proxy_fp))
		$proxy_contents .= fread($proxy_fp,4096);
	fclose($proxy_fp);
	$proxy_contents = substr($proxy_contents, strpos($proxy_contents,"\r\n\r\n")+4);
	
	//WARNING!!! Ugly hack! 
		if (!$proxy_contents) //We must return a string NOT a bool, so we return an empty string ^_^
			$proxy_contents = '';
	//End of ugly hack
	
	return $proxy_contents;
}


/**
* Creates directory tree recursively
* @param path to file
* @return void
*/
function recursive_make_directory($path)
{
	// This function creates the specified directory using mkdir().  Note
	// that the recursive feature on mkdir() is broken with PHP 5.0.4 for
	// Windows, so I have to do the recursion myself.
	if (!file_exists($path))
	{
		// The directory doesn't exist.  Recurse, passing in the parent
		// directory so that it gets created.
		recursive_make_directory(dirname($path));
		mkdir($path, 0777);
	}
}


/**
* Workhorse function, proccesses urls recursively
* @param absolute url from where to download
* @return void
*/
function proccess_url($download_url)
{
	$file_contents = proxy_url($download_url);
	
	if ($file_contents === false)
		die("ERROR: Could not download '$download_url'!");

	//If the last char is '/'
	if ( $download_url[strlen($download_url)-1] == '/' )
	{
		//It is an "index page" so proccess it and extract useful links
		
		//WARNING!!! Ugly and I mean UGLY HACK!
			$file_contents = str_replace('<hr noshade>',
				'', $file_contents); //This bitch is anoying because it's not valid XML syntax. So we'll kill it :)
		//End of ugly hack
		
		$dom = new DOMDocument(); //Fire up DomXML parser
		$dom->loadXML($file_contents); 
		foreach ($dom->getElementsByTagName('a') as $link) //Loop trought all <a> elements
		{
			$relative_url=$link->getAttribute('href');
			if ($relative_url != '../' && $relative_url != 'http://subversion.tigris.org/') //We want to filter out invalid links
			{
				$absolute_url = $download_url . $relative_url;
				//Recursion? Oh dear.
				proccess_url($absolute_url);
			}
		}
	}
	else 
	{
		//Ok, so it's actual content, all we need to do is to stick it where it belongs
		$relative_url = substr( $download_url, strlen(DOWNLOAD_URL) - 1, strlen($download_url) );
		
		echo "Downloading $relative_url...";
		
		$file_name = OUTPUT_DIR . $relative_url;
		
		recursive_make_directory(dirname($file_name)); //Create directory structure (if needed) where we'll save the file
		
		$file_handle = fopen($file_name, 'wb'); //ATENTION! Must open in binary mode. If you f*ck with this it's your own fault.
		if (!$file_handle) //Did we create the file?
			die("ERROR: Could not create file '$file_name'!");

		if ( fwrite($file_handle, $file_contents) === false ) //Did we write to the bloody file?
			die("ERROR: Could not write to file '$file_name'!");
		else
		{
			//All is well, so let's cleanup
			fclose($file_handle);
			echo " OK!\n";
		}
	}
}



proccess_url(DOWNLOAD_URL); //This little line is responsible for everything :)


?>